#include "mozunichardet.h"


MozUniCharDet::MozUniCharDet(PRUint32 aLanguageFilter)
 : nsUniversalDetector(aLanguageFilter)
{
}

MozUniCharDet::~MozUniCharDet()
{
}

NS_IMETHODIMP MozUniCharDet::DoIt(const char* aBuf, PRUint32 aLen,
    const char** oCharset, nsDetectionConfident &oConf)
{
    mResult = nsnull;
    this->Reset();
    nsresult rv = this->HandleData(aBuf, aLen);
    if (NS_FAILED(rv))
      return rv;
    this->DataEnd();
    if (mResult)
    {
      *oCharset=mResult;
      oConf = eBestAnswer;
    }
    return NS_OK;
}

void MozUniCharDet::Report(const char *aCharset)
{
  mResult = aCharset;
#ifdef DEBUG_chardet
  printf("New Charset Prober report charset %s . \r\n", aCharset);
#endif
}

